// MAME2KN - MAME 0.54 to KAWAK/NEBULA Cheat File Converter
// Programmed by Pugsy on 15 & 16 Sept 2001
// Beware it will overwrite .dat files in the same directory without warning

#include <stdio.h>
#include <string.h>

void Instructions (char *ProgramName)
{
	printf("## MAME2KN - MAME 0.54 -> KAWAK/NEBULA Cheat File Converter                  ##\n");
	printf("## Programmed by Pugsy on 15 & 16 Sept 2001                                  ##\n");
	printf("## This Converter will deal with type 000 (+500) cheats ONLY!                ##\n");
	printf("## If you want to change any other cheat types you will have to manually     ##\n"); 
	printf("## change them first to 000 (and 500).                                       ##\n"); 
	printf("## This converter is only for creating cps1, cps2 and neogeo cheats.         ##\n");
	printf("## Run this program in an empty folder with the MAME cheat file!             ##\n");
	printf("## If you want to batch convert use the cps1/cps2/neogeo/all bat files.      ##\n");
	printf("##                                                                           ##\n");
	printf("## Commandline : MAME2KN [MAME Cheat File] [Short Game Name]                 ##\n");
	printf("## Example : MAME2KN cheat.dat ddsom                                         ##\n");
}

int main (int argc, char **argv)
{
	char FormatOutput [32];			// Needed for formatting the output
	char InputCheatFilename [128] = "";	// The filename of the donor MAME cheat file
	FILE *FI;				// The file for the above
	char OutputCheatFilename [128] = "";	// The filename of the output cheat file - this will be generated from the RequiredGameName with a .dat on the end
	FILE *FO;				// The file for the above
	char RequiredGameName [9] = "";		// The name of the game whose cheats you want to rob....erm convert
	char *pointer;				// A pointer we use when we read the cheat file
	char MAMECheatLine [255];              	// Allows 255 characters per cheat line - should be plenty for even my cheat descriptions
	int  CheatNumber = -1;			// The count to fill the [] brackets,
	int i;					// Used for loop control

	struct MAMECheatStructure
	{
		char GameName [9]; 		// Holds the short gamename from MAME + null
		int  Cpu;			// This should always be 0 for cps1, cps2 and neogeo games - so no checks of this
		int  Address;			// This should always be of the form 123456 - not of interest here but will be for KN2MAME
		int  Data;			// The value being poked - will always be a byte
		int  Type;			// Only type 000 + 500 are acceptable for Kawaks or Nebula
		char Description [129];		// The displayed cheat description
		char Extra [129];		// The Extra Description Line
	} MAMECheat;

	if (2 <= argc)					// Let's get the first arguement from the commandline if it exists - the donor MAME cheat file's name.
		strcpy(InputCheatFilename, argv[1]);	// And store it in the InputCheatFilename

	if (3 <= argc)					// Let's get the second arguement from the commandline if it exists - the name of the game we are interested in.
	{
		strcpy(OutputCheatFilename, argv[2]);
		strcat(OutputCheatFilename,".dat");			//Add the .dat extension to the Output Cheat File
		strcpy(RequiredGameName, argv[2]);
		for (i = 0; i < strlen(RequiredGameName); i ++)
			RequiredGameName[i] = (unsigned char)tolower(RequiredGameName[i]);
	}

	if ((!InputCheatFilename[0]) || (!RequiredGameName[0]))    //Not enough arguements have been passed from the commandline - extra arguements will be ignored
	{
		Instructions(argv[0]);					//Print out the brief instuctions on how to use the program
		return(1);
	}

	if (!stricmp(InputCheatFilename, OutputCheatFilename))		//Check for identical input and output filenames
	{								//If you are using cheat.dat you will have no problems unless the game is called cheat!
		printf("\nSorry, the input and output cheat files must have different names!\n\n");
		return(2);
	}

	FI = fopen(InputCheatFilename,"r");    				// Open MAME Cheat File for reading - cheat file is perfectly safe

	if (!FI)							// Check to see if donor cheat file exists, if not print error and exit
	{
		printf("\nFailed to read from '%s'. Please check filename.\n\n", InputCheatFilename);
		return(3);
	}

	FO = fopen(OutputCheatFilename,"w+");    			// Open Output file for output (overwriting previous contents)

	if (!FO)							// Check to see if output cheat file has been opened for writing, if not print error and exit
	{
		printf("\nFailed to write to '%s'\n\n", OutputCheatFilename);
		return(3);
	}


	for(;;)								// Main loop body to read through the whole cheat file
	{
		if (CheatNumber == 4000)    				// This means that you can import upto 4000 cheat lines...more than enough surely
			break;

		if (fgets(MAMECheatLine, 256, FI) == NULL)
		break;

		#ifdef macintosh				// remove extraneous LF on Macs if it exists - don't know if this works - JCK uses it often?
			if (str[0] == '\r')
				strcpy(str,&str[1]);
		#endif

		if ((MAMECheatLine[0] == ';') || (!MAMECheatLine[0]))   //Non-cheatline checking
			continue;

		pointer = strtok(MAMECheatLine, ":");			//Get the name of the game (ie characters upto first ':')
		strcpy (MAMECheat.GameName, pointer);			//Put the name into the array

		if (!strcmp(RequiredGameName, MAMECheat.GameName))	//Compare the current cheat line gamename with the required gamename
		{							// Read the cheat line part by part and fill the array by reading from ':' to ':'
			pointer = strtok(NULL, ":");			// Extract and fill the array with the CPU [NOT USED]
			sscanf(pointer,"%d", &MAMECheat.Cpu);

			pointer = strtok(NULL, ":");			// Extract and fill the array with the address 
			sscanf(pointer,"%x", &MAMECheat.Address);

			pointer = strtok(NULL, ":");			// Extract and fill the array with the data
			sscanf(pointer,"%x", &MAMECheat.Data);

			pointer = strtok(NULL, ":");			// Extract and fill the array with the cheat type
			sscanf(pointer,"%d", &MAMECheat.Type);

			pointer = strtok(NULL, ":");			// Extract and fill the array with the description
			strcpy(MAMECheat.Description,pointer);

			strcpy(MAMECheat.Extra,"\n");			// Extract and fill the array with the extra description [NOT USED]
			pointer = strtok(NULL, ":");
			
			if (strstr(MAMECheat.Description,"\n") != NULL)
				MAMECheat.Description[strlen(MAMECheat.Description)-1] = 0;
			if (strstr(MAMECheat.Extra,"\n") != NULL)
				MAMECheat.Extra[strlen(MAMECheat.Extra)-1] = 0;
			
			if (MAMECheat.Type==0 || MAMECheat.Type==500)				// Check for type 000 or 500 - no support for other types
			{
				if (MAMECheat.Type==0)	
				{	
					CheatNumber++;						// Increment the cheat number by 1
					sprintf (FormatOutput, "", CheatNumber);      		// Format the output
					if (CheatNumber>=1)					// Lets not have two empty lines at the top		
						fprintf (FO, "\n\n");				// Put here so that linked parts work properly too
					fprintf (FO, "[%d]\n", CheatNumber);				// Will print the cheat number eg. '[4]' followed by a cr
					fprintf (FO, "%sName=%s\n", FormatOutput, MAMECheat.Description);// Will print the Name part eg 'Name=Infinite Lives PL1' followed by a cr
					fprintf (FO, "0=No,0,0\n");					// Will print the default setting '0=No,0,0' followed by a cr
					fprintf (FO, "%s1=Yes,%X,", FormatOutput, MAMECheat.Address^1);	// Will print the enable cheat eg. '1=Yes,123456,'
					fprintf (FO, "%s%02X", FormatOutput, MAMECheat.Data);		// Will print the poke value eg. '09'
				}
				else
				{
					fprintf (FO, "%s,%X,", FormatOutput, MAMECheat.Address^1);	// This is a type 500 cheat so it doesn't need all the crap just ',123456,'
					fprintf (FO, "%s%02X", FormatOutput, MAMECheat.Data);		// Will print the poke value eg. '09'
				}
			}
		}
	}

	fclose(FI);			//Close the input file
	fclose(FO);			//Close the output file
	printf("\n%d cheats have been added to %s for the game %s from %s", CheatNumber+1, OutputCheatFilename, RequiredGameName, InputCheatFilename );
	return(0);
}
